package firstGUI;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class CounterGUI extends JPanel 
  //Achtung schlechter Stil, nicht gut objektorientiert
  implements ActionListener{
	Counter c = new Counter();
	JButton plus = new JButton("+1");
	JButton plus10 = new JButton("+10");
	JButton minus = new JButton("-1");
	JButton minus10 = new JButton("-10");
	JButton reset = new JButton("reset");
	JLabel l = new JLabel(""+c.i);

	private class MinusAction implements ActionListener{
		@Override
		public void actionPerformed(ActionEvent e) {
			c.i--;
			l.setText(""+c.i);
		}		
	}
	
	CounterGUI(){
		add(l);
		add(plus);
		add(plus10);
		add(minus);
		add(minus10);
		add(reset);
		// verschiedene Art und Weisen, um einem
		//Knopf eine Aktion hinzuzufügen
		
		//1. globale Klasse schreiben, die die 
		//Schnittstelle ActionListener implementiert.
		// Davon ein Objekt erzeugen und dieses
		// mit addActionListener der GUI Komponenete
		// hizufügen
		plus.addActionListener(new PlusAction(c,l));

		//2. innere Klasse schreiben, die ActionListener
		// implementiert.
		//Vorteil: man kann alle Eigenschaften der
		//äußeren Klasse direkt verwenden.
		minus.addActionListener(new MinusAction());

		// 3. mit anonymer Klasse
		// es wird mit new ActionListener also mit new 
		// für eine Schnittstelle, direkt eine Klasse
		// definiert, die diese Schnittstelle implementiert
		// und von dieser Klasse direkt ein Objekt erzeugt
		// Die Klasse hat keinen Namen!
		reset.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				c.i=0;
				l.setText(""+c.i);
			}
		});
		//4. mit Lambda Ausdruck
		// Da ActionListener nur eine abstrakte Methode hat,
		// reicht es, diese Methode in Kurzschreibweise
		// zu notieren.
		// Das geht nur, wenn die Schnittstelle nur eine
		//abstrakte Methode hat
		// Solche Schnittstellen heißen: funktionale Schnittstellen
		plus10.addActionListener(e -> {
			c.i += 10;
			l.setText(""+c.i);
		});
		
		//5. GUI Klasse implementiert selbst ActionListener
		//fügt allen Knöpfen sich selbst hinzu
		//und macht ein dispatch auf die Quelle der Aktion
		minus10.addActionListener(this);
		plus10.addActionListener(this);
		//usw....
		//ACHTUNG schlechter Stil. Nicht Objektorientiert.
	}
	void showMe() {
		var f = new JFrame();
		f.add(this);
		f.pack();
		f.setVisible(true);
	}
	public static void main(String[] args) {
		new CounterGUI().showMe();
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==minus10) {
			c.i -= 10;
			l.setText(""+c.i);
		}else if(e.getSource()==plus10) {
			c.i += 10;
			l.setText(""+c.i);
			
		}
	}
}
